class CursorOverlayWindowClass{
	Hwnd := 0, Id := 0
	Width := 16, Height := 16
	Images := {}
	OnMouseMoveFunc := 0, RunOnMouseMove := 0
	
	__New(){
		this.OnMouseMoveFunc := Func("CursorOverlayWindowClass_OnMouseMove")
		
		Gui New, LastFound -Caption ToolWindow AlwaysOnTop +E%WS_EX_TRANSPARENT% +E%WS_EX_LAYERED% HwndWinHwnd
		Gui Show, % "w" this.Width " h" this.Height " NA Hide"
		this.Hwnd := WinHwnd, this.Id := "ahk_id " WinHwnd
		this.HBitmap := CreateDIBSection(this.Width, this.Height)
		this.DC := CreateCompatibleDC()
		SelectObject(this.DC, this.HBitmap)
		this.Graphics := Gdip_GraphicsFromHDC(this.DC)
		
		UpdateLayeredWindow(this.Hwnd, this.DC, 10, 10, this.Width, this.Height)
		WinMove, % this.Id, , 100, 100
	}
	
	LoadImage(ImageName){
		if(this.Images[ImageName])
			return this.Images[ImageName]
		
		return this.Images[ImageName] := Gdip_CreateBitmapFromFile("images\" ImageName ".ico")
	}
	
	Show(DrawIcons*){
		Gdip_GraphicsClear(this.Graphics, 0x00000000)
		
		for Key, ImageName in DrawIcons
			Gdip_DrawImage(this.Graphics, this.LoadImage(ImageName), 0, 0, this.Width, this.Height, 0, 0, this.Width, this.Height)
		
		MouseGetPos X, Y
		UpdateLayeredWindow(this.Hwnd, this.DC, X, Y, this.Width, this.Height)	
		this.SetCursorPos(X, Y)
		Gui % this.Hwnd ":Show", NoActivate
		
		this.RunOnMouseMove := 1
		CallThreadedFunction(this.OnMouseMoveFunc, this)
	}
	
	Hide(){
		Gui % this.Hwnd ":Hide"
		this.RunOnMouseMove := 0
	}
	
	SetCursorPos(X, Y){
		X += 16
		Y += 12
		WinMove % this.Id, , %X%, %Y%
	}
}

CursorOverlayWindowClass_OnMouseMove(this){
	while(this.RunOnMouseMove){
		MouseGetPos X, Y
		this.SetCursorPos(X, Y)
		Sleep 16 ; 16 ms ~ 60 frames per second
	}
}