; -- Initialize variables
; -----------------------------------------------------------------
{

global MainWinHwnd, MainWinStatusBarHwnd, MainWinOldWindowProc
	 , MainWinAddBtnHighlightHwnd, MainWinAddBtnNames := {}, MainWinAddControlTypes := []
	 , MainWinClipboard := {}
	 , MainWinControlTypeIcons := {}
	 
	 , MainWinDebugWinHwnd := 0, MainWinDebugTextHwnd := 0
	 , MainWinDebugWinFunc := Func("OnMainWinDebugWinOutputFilter")
	 , MainWinDebugWinFilter := ["ControlIndexes/\d+$", "^/Controls/\d+$"]

}

; -- Functions
; -----------------------------------------------------------------

MainWinCreateGui(){
	Gui Main:New, HwndMainWinHwnd LabelOnMainWin, %APP_NAME%
	Gui Main:Margin, 5, 5
	
	; Main Menu
	
		MainWinCreateGuiMenuItem("File", "&New", "^N", "", "new")
		MainWinCreateGuiMenuItem("File", "&Open", "^O", "", "open")
		MainWinCreateGuiMenuItem("File", "&Save", "^S", "", "save")
		MainWinCreateGuiMenuItem("File", "Save &As", "^+S", "", "save-as")
		MainWinCreateGuiMenuItem("File", "&Export", "^!+S", "", "export")
		MainWinCreateGuiMenuItem("File", "&Preview", "F5", "", "preview")
		MainWinCreateGuiMenuItem("File", "", "")
		MainWinCreateGuiMenuItem("File", "Settings", "", "", "settings")
		MainWinCreateGuiMenuItem("File", "", "")
		MainWinCreateGuiMenuItem("File", "E&xit", "^!X")
	MainWinCreateGuiMenuItem("Main", "&File", "", "File")
	
		MainWinCreateGuiMenuItem("Edit", "Cut", "EditorWinGroup ^X", "", "cut")
		MainWinCreateGuiMenuItem("Edit", "Copy", "EditorWinGroup ^C", "", "copy")
		MainWinCreateGuiMenuItem("Edit", "Paste", "EditorWinGroup ^V", "", "paste")
		MainWinCreateGuiMenuItem("Edit", "Select All", "EditorWinGroup ^A", "", "select-all")
		MainWinCreateGuiMenuItem("Edit", "Deselect All", "EditorWinGroup ^D", "", "deselect")
		MainWinCreateGuiMenuItem("Edit", "Delete", "EditorWinGroup Delete", "", "delete")
		MainWinCreateGuiMenuItem("Edit", "", "")
		MainWinCreateGuiMenuItem("Edit", "Snap Control to Grid", "^!S", "", "")
			MainWinCreateGuiMenuItem("Align", "Left Edges", "", "", "align-left")
			MainWinCreateGuiMenuItem("Align", "Horizontal Centers", "", "", "align-center")
			MainWinCreateGuiMenuItem("Align", "Right Edges", "", "", "align-right")
			MainWinCreateGuiMenuItem("Align", "", "")
			MainWinCreateGuiMenuItem("Align", "Top Edges", "", "", "align-top")
			MainWinCreateGuiMenuItem("Align", "Vertical Centers", "", "", "align-middle")
			MainWinCreateGuiMenuItem("Align", "Bottom Edges", "", "", "align-bottom")
		MainWinCreateGuiMenuItem("Edit", "Align", "", "Align", "")
			MainWinCreateGuiMenuItem("Distribute", "Left Edges", "", "", "distr-left")
			MainWinCreateGuiMenuItem("Distribute", "Horizontal Centers", "", "", "distr-center")
			MainWinCreateGuiMenuItem("Distribute", "Right Edges", "", "", "distr-right")
			MainWinCreateGuiMenuItem("Distribute", "", "")
			MainWinCreateGuiMenuItem("Distribute", "Top Edges", "", "", "distr-top")
			MainWinCreateGuiMenuItem("Distribute", "Vertical Centers", "", "", "distr-middle")
			MainWinCreateGuiMenuItem("Distribute", "Bottom Edges", "", "", "distr-bottom")
		MainWinCreateGuiMenuItem("Edit", "Distribute", "", "Distribute", "")
	MainWinCreateGuiMenuItem("Main", "&Edit", "", "Edit")
	
		MainWinCreateGuiMenuItem("View", "Show &Grid", "^G")
		MainWinCreateGuiMenuItem("View", "Snap to Grid", "^+G", "", "grid-snap-on")
			MainWinCreateGuiMenuItem("GridType", "Dot Grid", "", "", "grid-dot")
			MainWinCreateGuiMenuItem("GridType", "Line Grid", "", "", "grid-line")
		MainWinCreateGuiMenuItem("View", "Grid Type", "", "GridType")
		MainWinCreateGuiMenuItem("View", "Grid Colour")
		MainWinCreateGuiMenuItem("View", "Grid +", "^NumpadAdd")
		MainWinCreateGuiMenuItem("View", "Grid -", "^NumpadSub")
	MainWinCreateGuiMenuItem("Main", "&View", "", "View")
	
		MainWinCreateGuiMenuItem("Help", "&Help", "F1", "", "help")
		MainWinCreateGuiMenuItem("Help", "&About", "", "", "about")
		MainWinCreateGuiMenuItem("Help", "", "")
		MainWinCreateGuiMenuItem("Help", "&Debug Inspect", "F12", "", "debug-inspect")
	MainWinCreateGuiMenuItem("Main", "&Help", "", "Help")
	
	Gui Main:Menu, MainMenu
	
	if(Settings.ShowGrid)
		Menu ViewMenu, Check, % GetMenuItem("View>ShowGrid")
	if(Settings.SnapToGrid)
		Menu ViewMenu, Check, % GetMenuItem("View>SnapToGrid")
	if(Settings.GridType = "Line")
		Menu GridTypeMenu, Check, % GetMenuItem("GridType>LineGrid")
	else
		Menu GridTypeMenu, Check, % GetMenuItem("GridType>DotGrid")
	
	; Create the control toolbar
	
	Gui Main:Add, Picture, x0 y0 HwndMainWinAddBtnHighlightHwnd, images\btn-selection.ico
	GuiControl Main:Hide, %MainWinAddBtnHighlightHwnd%
	
	ButtonMargin := 3, SectionMargin := 3
	MainWinCreateGuiToolbarButton("Text", "ui-label", 2)
	MainWinCreateGuiToolbarButton("Edit", "ui-text-field")
	MainWinCreateGuiToolbarButton("UpDown", "ui-spin")
	MainWinCreateGuiToolbarButton("Picture", "ui-picture")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("Button", "ui-button")
	MainWinCreateGuiToolbarButton("Checkbox", "ui-check-box")
	MainWinCreateGuiToolbarButton("Radio", "ui-radio-button")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("DropDownList", "ui-drop-down-list")
	MainWinCreateGuiToolbarButton("ComboBox", "ui-combo-box")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("ListBox", "ui-list-box")
	MainWinCreateGuiToolbarButton("ListView", "ui-list-view")
	MainWinCreateGuiToolbarButton("TreeView", "ui-tree-view")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("Link", "ui-link")
	MainWinCreateGuiToolbarButton("Hotkey", "ui-hotkey")
	MainWinCreateGuiToolbarButton("DateTime", "ui-date-time")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("MonthCal", "ui-month-cal")
	MainWinCreateGuiToolbarButton("Slider", "ui-slider")
	MainWinCreateGuiToolbarButton("Progress", "ui-progress")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("GroupBox", "ui-group-box")
	MainWinCreateGuiToolbarButton("Tab2", "ui-tab")
	MainWinCreateGuiToolbarButton("StatusBar", "ui-status-bar")
		MainWinCreateGuiToolbarButton(0)
	MainWinCreateGuiToolbarButton("ActiveX", "ui-active-x")
	MainWinCreateGuiToolbarButton("Custom", "ui-custom")
		
	Gui Add, StatusBar, HwndMainWinStatusBarHwnd,
	MainWinSetStatusBarIcon(Settings.SnapToGrid ? "grid-snap-on" : "grid-snap-off")
	
	Gui Main:Show, x346 y7 w766 h58
}

MainWinCreateGuiMenuItem(MenuName, ItemName, Shortcut := "", Submenu := "", IconName := ""){
	; Create a submenu
	if(Submenu != ""){
		FullItemName := ItemName, ItemPath := ""
		Menu %MenuName%Menu, Add, %FullItemName%, :%Submenu%Menu
	}
	else{
		; Menu accelerator key only work for the main window so if we map this items accelerator key to an application wide hotkey to allow
		; the shortcut to be used while any of the applications windows are active
		FullItemName := ItemName
		if(Shortcut != ""){
			if( (Index := InStr(Shortcut, " ", 0, 0)) ){
				WindowGroup := SubStr(Shortcut, 1, Index - 1)
				Shortcut := SubStr(Shortcut, Index + 1)
			}
			else
				WindowGroup := ""
			
			StringReplace, ShortcutName, Shortcut, +, Shift+, 1
			StringReplace, ShortcutName, ShortcutName, ^, Ctrl+, 1
			StringReplace, ShortcutName, ShortcutName, !, Alt+, 1
			FullItemName .= "`t" ShortcutName
			
			SetApplicationHotKey(Shortcut, "OnMainWinMainMenuItemClick", "", WindowGroup)
			
			MainMenuAccKeys[Shortcut " - 0"] := MenuName
			MainMenuAccKeys[Shortcut " - 1"] := ItemName
		}
		
		; Menu items are identified by their text but this text may include &, spaces, tabs and the item's accelerator key which can make working with the menu difficult.
		; Map a cleaned up menu "path" (eg. File>Save) to the actual menu text so that we can use the simpler menu path later on to work with the menu
		if(ItemName != "" ) ; This item is a separator if it has no name
			MainMenuAccKeys[ItemPath := MenuName ">" CleanMenuItemName(ItemName)] := FullItemName
		
		Menu %MenuName%Menu, Add, %FullItemName%, OnMainWinMainMenuItemClick
	}
	
	if(IconName)
		Menu %MenuName%Menu, Icon, %FullItemName%, images\%IconName%.ico, 1, 16
}

MainWinCreateGuiToolbarButton(VarName := "", IconName = "", LeftMargin := 1){
	static ButtonMargin := 3, SectionMargin := 3
		 , AddBtnText, AddBtnEdit, AddBtnUpDown, AddBtnPicture
		 , AddBtnButton, AddBtnCheckbox, AddBtnRadio
		 , AddBtnDropDownList, AddBtnComboBox
		 , AddBtnListBox, AddBtnListView, AddBtnTreeView
		 , AddBtnLink, AddBtnHotkey, AddBtnDateTime
		 , AddBtnMonthCal, AddBtnSlider, AddBtnProgress
		 , AddBtnGroupBox, AddBtnTab2, AddBtnStatusBar 
		 , AddBtnActiveX, AddBtnCustom
	
	LeftMargin := (LeftMargin != 2 ? "+" : "") . (LeftMargin ? ButtonMargin : SectionMargin)
	ControlType := Varname, Varname := "AddBtn" VarName
	
	if(IconName){
		MainWinControlTypeIcons[ControlType] := IconName
		
		IconName := "images\" IconName ".ico"
		Gui Main:Add, Button, gOnMainWinControlAddClick HwndBtnHwnd w28 h28 x%LeftMargin% y%ButtonMargin% v%VarName%
		SetControlTooltip(BtnHwnd, ControlType, 1)
		GuiButtonIcon(BtnHwnd, IconName, 1, 22, 6)
		MainWinAddBtnNames[Varname] := BtnHwnd
		
		MainWinAddControlTypes.Insert([ControlType, IconName])
	}
	else{
		SeparatorY := SectionMargin - 2
		Gui Main:Add, GroupBox, w4 h33 x+%SectionMargin% y-%SeparatorY%
		
		MainWinAddControlTypes.Insert("")
	}
}

MainWinExecuteMainMenuAction(MenuName, ItemName){
	if(CurrentAppAction)
		return
	
	Item := MenuName ">" ItemName
	;~ out("  MainWinExecuteMainMenuAction: " Item)
	
	if(MenuName = "Align"){
		AlignControls(ItemName)
	}
	
	else if(MenuName = "Distribute"){
		DistributeControls(ItemName)
	}
	
	else if(Item = "File>New"){
		CreateNewGui()
	}
	
	else if(Item = "File>Open"){
		FileLoad()
	}
	
	else if(Item = "File>Save" or Item = "File>SaveAs"){
		FileSave(Item = "File>SaveAs")
	}
	
	else if(Item = "File>Export"){
		FileExport()
	}
	
	else if(Item = "File>Preview"){
		FileExport(1)
	}
	
	else if(Item = "File>Exit"){
		ExitApp
	}
	
	else if(Item = "Edit>SnapControlToGrid"){
		for ControlHwnd in Selection.Controls{
			GuiControlGet Control, Editor:Pos, %ControlHwnd%
			SnapToGrid(ControlX, ControlY)
			GuiControl Editor:Move, %ControlHwnd%, x%ControlX% y%ControlY%
			
			ControlData := CurrentGui.Controls[ControlHwnd]
			ControlData.Position[1] := ControlX
			ControlData.Position[2] := ControlY
			
			EditorWinUpdateHighlight(ControlHwnd)
		}
		
		OnPropertyWinPropertyChange("Common", "Position")
		
		EditorWinUpdateResizeHandles()
	}
	
	else if(Item = "Edit>Cut"){
		MainWinClipboard := {}
		for ControlHwnd in Selection.Controls{
			ControlData := CurrentGui.Controls[ControlHwnd]
			MainWinClipboard[ControlData.Index] := ControlData
			DeleteControl(ControlHwnd, 0)
		}
		EditorWinSelectControl(0, "clear")
	}
	
	else if(Item = "Edit>Copy"){
		MainWinClipboard := {}
		for ControlHwnd in Selection.Controls{
			ControlData := CurrentGui.Controls[ControlHwnd]
			MainWinClipboard[ControlData.Index] := CopiedData := DeepCloneObject(ControlData)
			for Index, PropertyName in ControlTypeOptions.ResetDataOnCopy
				CopiedData.Remove(PropertyName)
		}
	}
	
	else if(Item = "Edit>Paste"){
		EditorWinSelectControl(0, "clear")
		X := Y := ControlCount := 0
		
		for Index, ControlData in MainWinClipboard
			  X += ControlData.Position[1] + (ControlData.Size[1] != "" ? ControlData.Size[1] : 0) / 2
			, Y += ControlData.Position[2] + (ControlData.Size[2] != "" ? ControlData.Size[2] : 0) / 2
			, ControlCount++
		EditorWinGetMousePos(MouseX, MouseY, 1, 1)
		  X := Round(X / ControlCount) - MouseX
		, Y := Round(Y / ControlCount) - MouseY
		for Index, ControlData in MainWinClipboard{
			ControlData := DeepCloneObject(ControlData)
			ControlData.Position[1] -= X, ControlData.Position[2] -= Y
			ControlData.Index := CurrentGui.NextIndex ; Set the new control Index first because EditorWinCreateControlFromData expects a valid Index
			ControlHwnd := EditorWinCreateControlFromData(ControlData)
			AddControl(ControlHwnd, ControlData.ControlType, ControlData)
			EditorWinSelectControl(ControlHwnd, "add")
		}
		
		EditorWinStartMoveSelection()
	}
	
	else if(Item = "Edit>SelectAll"){
		EditorWinSelectControl(0, "all")
	}
	
	else if(Item = "Edit>DeselectAll"){
		EditorWinSelectControl(0, "clear")
	}
	
	else if(Item = "Edit>Delete"){
		for ControlHwnd in Selection.Controls
			DeleteControl(ControlHwnd, 0)
		EditorWinSelectControl(0, "clear")
	}
	
	else if(Item = "View>ShowGrid"){
		ShowGrid(!Settings.ShowGrid)
		ShowToolTip("Show Grid: " (Settings.ShowGrid ? "On" : "Off"), "Window", EditorWinHwnd)
	}
	
	else if(Item = "View>SnapToGrid"){
		SetGridSnap(!Settings.SnapToGrid)
	}
	
	else if(Item = "GridType>LineGrid"){
		Settings.GridType := "Line"
		Menu GridTypeMenu, Check, % GetMenuItem("GridType>LineGrid")
		Menu GridTypeMenu, Uncheck, % GetMenuItem("GridType>DotGrid")
		EditorWinUpdateGrid(1)
	}
	
	else if(Item = "GridType>DotGrid"){
		Settings.GridType := "Dot"
		Menu GridTypeMenu, Uncheck, % GetMenuItem("GridType>LineGrid")
		Menu GridTypeMenu, Check, % GetMenuItem("GridType>DotGrid")
		EditorWinUpdateGrid(1)
	}
	
	else if(Item = "View>GridColour"){
		SetModalMode(), Colour := ChooseColor(Settings.GridColour, MainWinHwnd), SetModalMode(0)
		if(!ErrorLevel){
			Colour := ColourValueToRGBHex(Colour)
			if(Settings.GridColour != Colour){
				Settings.GridColour := Colour | 0xFF000000
				EditorWinUpdateGrid(1)
			}
		}
	}
	
	else if(Item = "View>Grid+"){
		if(Settings.GridSize < 50)
			Settings.GridSize += 2
		ShowToolTip("Grid Size: " Settings.GridSize, "Window", EditorWinHwnd)
		EditorWinUpdateGrid(1)
	}
	
	else if(Item = "View>Grid-"){
		if(Settings.GridSize > 4)
			Settings.GridSize -= 2
		ShowToolTip("Grid Size: " Settings.GridSize, "Window", EditorWinHwnd)
		EditorWinUpdateGrid(1)
	}
	
	else if(Item = "Help>DebugInspect"){
		CurrentAppAction := EditorMouseDownMode := "DebugInspect"
		EditorWinListenForEscape()
		MainWinStatusText("Click on a control to view its raw data`t`tShift: Show All | Cancel: Escape")
		CursorOverlayWindow.Show("debug-inspect")
	}
}

MainWinSetControlAddMode(ControlName, AddType := ""){
	if(ControlName = "" and AddType = ""){
		CursorOverlayWindow.Hide()
		GuiControl Main:Hide, %MainWinAddBtnHighlightHwnd%
		return
	}
	
	if(CurrentAppAction and SubStr(CurrentAppAction, 1, 3) != "Add")
		return
	
	; Called when one of the control toolbar buttons is clicked, this function will set the mode, highlight the button and update the status bar to indicate the mode
	
	AddType := ControlName != "" ? SubStr(ControlName, 7) : SubStr(AddType, 4)
	ModifierKeys := "Cancel: Escape | Add multiple: Shift" (ControlTypeOptions[AddType].AddModifierKeys ? ControlTypeOptions[AddType].AddModifierKeys : "")
	MainWinStatusText("Add " AddType "`t`t" ModifierKeys)
	if(ControlName = "")
		return
	
	GuiControlGet AddButton, Main:Pos, % MainWinAddBtnNames[ControlName]
	AddButtonX -= 2, AddButtonY -= 2
	GuiControl Main:Move, %MainWinAddBtnHighlightHwnd%, x%AddButtonX% y%AddButtonY%
	GuiControl Main:Show, %MainWinAddBtnHighlightHwnd%
	
	WinActivate ahk_id %EditorWinHwnd%
	; Force the button to redraw so that it appears on top of the highlight image
	GuiControlGet AddButtonHwnd, Hwnd, %ControlName%
	WinSet Redraw, , ahk_id %AddButtonHwnd%
	
	EditorMouseDownMode := "Add" AddType
	CurrentAppAction := EditorMouseDownMode
	EditorWinListenForEscape()
	
	CursorOverlayWindow.Show(MainWinControlTypeIcons[AddType], "add-cursor-overlay")
}

MainWinSetStatusBarIcon(IconName := "", IconNumber := 1, PartNumber := 1){
	static StatusBarIcons := {}
	Gui Main:Default
	
	IconName := "images\" IconName ".ico"
	Key := IconName "|" IconNumber
	if(!StatusBarIcons[Key]){
		SendMessage SB_SETICON, % PartNumber - 1, 0, , ahk_id %MainWinStatusBarHwnd% ; First remove the current icon to ensure that it is not destroyed
		StatusBarIcons[Key] := SB_SetIcon(IconName, IconNumber, PartNumber)
	}
	else
		SendMessage SB_SETICON, % PartNumber - 1, % StatusBarIcons[Key], , ahk_id %MainWinStatusBarHwnd%
}

MainWinShowDebugWindow(ByRef DebugText){
	if(!MainWinDebugWinHwnd){
		W := Settings.HasKey("DebugInspectorW") ? Settings.DebugInspectorW : 500
		H := Settings.HasKey("DebugInspectorH") ? Settings.DebugInspectorH : A_ScreenHeight - 80
		X := Settings.HasKey("DebugInspectorX") ? Settings.DebugInspectorX : A_ScreenWidth - W - 18
		Y := Settings.HasKey("DebugInspectorY") ? Settings.DebugInspectorY : 10
		Gui MainWinDebugWin:New, Owner%MainWinHwnd% ToolWindow Resize HwndMainWinDebugWinHwnd LabelOnMainWinDebugWin
		Gui MainWinDebugWin:Show, Hide x%X% y%Y% w%W% h%H%, %APP_NAME% - Debug Inspector
		Gui MainWinDebugWin:Font, s9.2, Lucida Console
		Gui MainWinDebugWin:Add, Edit, % "HwndMainWinDebugTextHwnd Multi ReadOnly x2 y2 w" (W - 4) " h" (H - 2)
		SubClassWindow(MainWinDebugWinHwnd, "OnMainWinDebugWinWindowProc")
	}
	
	GuiControl MainWinDebugWin:, %MainWinDebugTextHwnd%, %DebugText%
	Gui MainWinDebugWin:Show, NoActivate
}

MainWinStatusText(Text := ""){
	static CurrentStatusText := ""
	if(CurrentStatusText = Text)
		return
	
	Gui Main:Default
	SB_SetText(Text)
	CurrentStatusText := Text
}

; -- Events
; -----------------------------------------------------------------

MainWinSubroutinesDef(){
	OnMainWinClose:
		OnMainWinClose()
	return
	
	OnMainWinControlAddClick:
		OnMainWinControlAddClick()
	return
	
	OnMainWinMainMenuItemClick:
		OnMainWinMainMenuItemClick()
	return
}

OnMainWinClose(){
	ExitApp
}

OnMainWinControlAddClick(){
	MainWinSetControlAddMode(A_GuiControl)
}

OnMainWinDebugWinOutputFilter(ByRef Key, ByRef Value, Index){
	if(Index = 1)
		Value := "Hwnd[" FormatHex(Value) "]"
	else if(Index = 2)
		Key := "Hwnd[" FormatHex(Key) "]"
}

OnMainWinDebugWinWindowProc(hwnd, msg, wParam, lParam){
	Critical
	
	if(msg = WM_MOVE or msg = WM_SIZE){
		X := Y := 0
		GetClientSize(MainWinDebugWinHwnd, W, H)
		GetWindowRect(MainWinDebugWinHwnd, X, Y, 0, 0)
		Settings.DebugInspectorW := W
		Settings.DebugInspectorH := H
		Settings.DebugInspectorX := X
		Settings.DebugInspectorY := Y
		
		if(msg = WM_SIZE){
			GuiControl MainWinDebugWin:Move, %MainWinDebugTextHwnd%, % "w" (W - 4) " h" (H - 2)
		}
	}
	
	return DllCall("CallWindowProc", Ptr,A_EventInfo, Ptr,hwnd, UInt,msg, Ptr,wParam, Ptr,lParam)
}

OnMainWinMainMenuItemClick(){
	; This function has been called from a hotkey so we need to fetch the menu and item name by looking up the hotkey
	if(A_TimeSinceThisHotkey = 0){
		
		MenuName := MainMenuAccKeys[A_ThisHotkey " - 0"]
		ItemName := MainMenuAccKeys[A_ThisHotkey " - 1"]
		
		if(MenuName = "" or ItemName = "" or MainMenuAccKeys[MenuName ">" ItemName "-Disabled"])
			return
	}
	; The menu item has been activated directly so the special A_* menu variables will contain the menu and item names
	else{
		MenuName := A_ThisMenu
		ItemName := A_ThisMenuItem
	}
	
	; Be convention all menu names will end in Menu, strip it from the name if it is there
	MenuName := SubStr(MenuName, -3) = "Menu" ? SubStr(MenuName, 1, -4) : MenuName
	ItemName := CleanMenuItemName(ItemName)
	
	MainWinExecuteMainMenuAction(MenuName, ItemName)
}