﻿global PropertiesDef := {}
PropertiesDef.PropertyTypeOptions := {NoSelectToggle: 1}

PropertiesDef.Gui := {ControlType: "Gui|1"
	, Properties: ["Window"
		, {Prop: "Title"
			, Type: "Text", Default: "Untitled GUI"
			, CustomOutput: 1}
		, {Prop: "Position"
			, Type: "XY", OutputPrefix: ["x", "y"]}
		, {Prop: "Size"
			, Type: "XY", Default: [400, 300], Range: [0, ""]
			, OutputPrefix: ["w", "h"]}
		, {Prop: "BackgroundColour", Name: "Background Colour"
			, Type: "MultiText", MultiTextAction: "ColourDialog"
			, CustomOutput: 1}
		, {Prop: "ControlColour", Name: "Control Colour"
			, Type: "MultiText", MultiTextAction: "ColourDialog"
			, CustomOutput: 1}
		, {Prop: "C", Name: "Text Colour", Default: ""
			, Type: "MultiText", MultiTextAction: "ColourDialog"
			, CustomOutput: 1}
		, {Prop: "Font"
			, Type: "Font", ColourPropertyGroup: "Gui", ColourProperty: "C"
			, CustomOutput: 1}]}

PropertiesDef.GuiOptions := {ControlType: "Gui|2"
	, Properties: ["Window Options"
		, {Prop: "AlwaysOnTop"}
		, {Prop: "Border"}
		, {Prop: "Caption"
			, Default: "Yes"}
		, {Prop: "Delimiter"
			, Type: "Text", Limit: 5}
		, {Prop: "Disabled"}
		, {Prop: "DPIScale"
			, Default: "Yes"}
		, {Prop: "Hwnd"
			, Type: "Var"}
		, {Prop: "Label"
			, Type: "Label"}
		, {Prop: "LastFound"}
		, {Prop: "LastFoundExist"}
		, {Prop: "MaximizeBox"
			, Default: ""}
		, {Prop: "MinimizeBox"
			, Default: ""}
		, {Prop: "MinSize"
			, Type: "XY", Range: [0, ""], SplitString: " x ", OutputAsDimensions: 1}
		, {Prop: "MaxSize"
			, Type: "XY", Range: [0, ""], SplitString: " x ", OutputAsDimensions: 1}
		, {Prop: "OwnDialogs"}
		, {Prop: "Owner"
			, Type: "Var"}
		, {Prop: "Parent"
			, Type: "Var"}
		, {Prop: "Resize"}
		, {Prop: "SysMenu"
			, Default: "Yes"}
		, {Prop: "Theme"
			, Default: "Yes"}
		, {Prop: "ToolWindow"}]}

PropertiesDef.GuiShowOptions := {ControlType: "Gui|3"
	, Properties: ["Show Options"
		, {Prop: "Autosize"}
		, {Prop: "Center"}
		, {Prop: "xCenter", Name: "Center X"}
		, {Prop: "yCenter", Name: "Center Y"}
		, {Prop: "Minimize"}
		, {Prop: "Maximize"}
		, {Prop: "Restore"}
		, {Prop: "NoActivate"}
		, {Prop: "NA"}
		, {Prop: "Hide"}]}

PropertiesDef.GuiOutputOptions := {ControlType: "Gui|4"
	, Properties: ["Output Options"
		, {Prop: "GuiName", Name: "Gui Name"
			, Type: "Var"}
		, {Prop: "CommandComma", Name: "Comma After Command"}
		, {Prop: "NamedConstants", Name: "Named Constants"
			, Default: "Yes"}
		, {Prop: "GuiCloseEvent", Name: "GuiClose Event"
			, Default: "Yes"}
		, {Prop: "GuiEscapeEvent", Name: "GuiEscape Event"
			, Default: "Yes"}
		, {Prop: "GenSubroutines", Name: "Event Sub-routines"
			, Default: "Yes"}
		, {Prop: "CommentSections", Name: "Comment Sections"
			, Default: "Yes"}
		, {Prop: "ExtraComments", Name: "Extra Comments"
			, Default: "Yes"}
		, {Prop: "ChangeUpDownOrder", Name: "Change UpDown Order"
			, Default: "Yes"}
		, {Prop: "EOL", Name: "Line Endings"
			, Type: "List", Options: "Windows (\r\n)|Unix (\n)|Max (\r)"
			, Default: "Unix (\n)"}]}

PropertiesDef.Common := {ControlType: "Text,Edit,UpDown,Picture,Button,Checkbox,Radio,DropDownList,ComboBox,ListBox,ListView,TreeView,Link,Hotkey,DateTime,MonthCal,Slider,Progress,GroupBox,Tab2,StatusBar,ActiveX,Custom|1"
	, Properties: CommonProperties := ["Control"
		, {Prop: "Id", Name: "Control Id"
			, Type: "Text", ReadOnly: 1, NoSelect: 1, CustomOutput: 1}
		, {Prop: "Text"
			, Type: "MultiText", CustomOutput: 1
			, ControlTypes: {"": ""
				, UpDown: {Name: "Value"
					, Type: "Int", Range: ["UpDown", "Range"]}
				, Picture: {Name: "Image File"
					, MultiTextAction: "PictureLoadMenu"
					, EditPropertyName: "PictureFileName"}
				, DropDownList: {Name: "Options"
					, MultiTextLayout: "Options", GuiDelimiter: 1
					, UpdateAfter: "Choose"}
				, ComboBox: {Name: "Options"
					, MultiTextLayout: "Options", GuiDelimiter: 1}
				, ListBox: {MultiTextLayout: "Options", GuiDelimiter: 1}
				, ListView: {Name: "Columns"
					, MultiTextLayout: "Options", GuiDelimiter: 1
					, EditPropertyName: "ListViewColumns"}
				, TreeView: {Disable: 1}
				, DateTime: {Name: "Date Format"
					, Type: "List", Options: "Short Date|Long Date|Time", OptionValues: "|LongDate|Time", IsComboBox: 1
					, Default: "Short Date", RecreateOnEdit: 1}
				, MonthCal: {Name: "Date"
					, Type: "DateRange", AllowSingle: 1, NoTime: 1
					, EditPropertyName: "MonthCalDate", EmptyValueVar: "A_Now"}
				, Slider: {Name: "Position"
					, Type: "Int", Range: ["Slider", "Range"]}
				, Progress: {Name: "Position"
					, Type: "Int", Range: ["Progress", "Range"]}
				, Tab2: {Name: "Tabs"
					, MultiTextLayout: "Options", GuiDelimiter: 1
					, UpdateAfter: "Choose"}
				, ActiveX: {Name: "ActiveX Component"
					, Type: "Text"}
				, Custom: {Name: "Class Name"
					, Type: "Text", OutputName: "Class", OutputNoText: 1}} } ]}
{
; Split into multiple expressions because of the expression token limit
CommonProperties.Insert(CommonProperties.MaxIndex() + 1
	, {Prop: "Position"
		, Type: "XY"
		, OutputPrefix: ["x", "y"]
		, ControlTypes: {StatusBar: {Disable: 1}}}
	, {Prop: "Size"
		, Type: "XY", Range: [0, ""]
		, OutputPrefix: ["w", "h"]
		, ControlTypes: {"": ""
			, StatusBar: {Disable: 1}
			, DropDownList: {StartEmptyY: 1}
			, ComboBox: {StartEmptyY: 1}} }
	, {Prop: "AltSubmit"}
	, {Prop: "Background"
		, Default: "Yes", UsePropertyNameOnEdit: 1
		, ControlTypes: {"": ""
			, Progress: {Type: "MultiText", MultiTextAction: "ColourDialog"
				, Default: "", UsePropertyNameOnEdit: 0
				, CheckAfterEdit: ["", "Progress", "Smooth"]}
			, ListView: {Type: "MultiText", MultiTextAction: "ColourDialog"
				, Default: "", UsePropertyNameOnEdit: 0}
			, TreeView: {Type: "MultiText", MultiTextAction: "ColourDialog"
				, Default: "", UsePropertyNameOnEdit: 0}} }
	, {Prop: "BackgroundTrans"
		, UsePropertyNameOnEdit: 1}
	, {Prop: "Border"
		, ControlTypes: {"": ""
			, ActiveX: {IgnoreProperty: 1}
			, Custom: {IgnoreProperty: 1}} }
	, {Prop: "C", Name: "Text Colour"
		, Type: "MultiText", MultiTextAction: "ColourDialog"
		, CustomOutput: 1
		, ControlTypes: {"": ""
			, Progress: {Name: "Foreground Colour", CheckAfterEdit: ["", "Progress", "Smooth"]}} })
}
{
; Split into multiple expressions because of the expression token limit
CommonProperties.Insert(CommonProperties.MaxIndex() + 1
	, {Prop: "Disabled"
		, UsePropertyNameOnEdit: ["Enable", "Disable"]}
	, {Prop: "Font"
		, Type: "Font", ColourPropertyGroup: "Common", ColourProperty: "C"
		, CustomOutput: 1}
	, {Prop: "G", Name: "G-Label"
		, Type: "Label", FullOutputOnly: 1}
	, {Prop: "Hidden"}
	, {Prop: "HScroll"
		, Default: ""
		, ControlTypes: {"": ""
			, ListBox: {Type: "IntToggle"}} }
	, {Prop: "Hwnd"
		, Type: "Var", CustomOutput: 1}
	, {Prop: "Justify"
		, Type: "List", Options: "None|Left|Center|Right", Default: "None"}
	, {Prop: "Parent"
		, Type: "Control", AllowParentPage: 1
		, AllowedTypes: "Tab2"
		, ControlTypes: {"": ""
			, Tab2: {Disable: 1}
			, StatusBar: {Disable: 1}}}
	, {Prop: "Section"}
	, {Prop: "Tabstop"
		, Default: "Yes"}
	, {Prop: "Theme"
		, Default: ""}
	, {Prop: "V", Name: "Variable"
		, Type: "Var", FullOutputOnly: 1}
	, {Prop: "VScroll"
		, Default: ""}
	, {Prop: "Wrap", Name: "Word Wrap"
		, Default: "Yes", UsePropertyNameOnEdit: 1
		, ControlTypes: {"": ""
			, Edit: {RecreateOnEdit: 1}
			, UpDown: {Name: "Wrap"
				, Default: "No"}
			, GroupBox: {Name: "Wrap"
				, Default: "", RedrawAfterEdit: 2}} })
}

PropertiesDef.Edit := {ControlType: "Edit|2"
	, Properties: ["Edit Properties"
		, {Prop: "Limit"
			, Type: "Int"}
		, {Prop: "Lowercase"}
		, {Prop: "Multi"
			, Default: ""}
		, {Prop: "Number"}
		, {Prop: "Password"
			, Type: "TextToggle", Limit: 1}
		, {Prop: "ReadOnly"}
		, {Prop: "T", Name: "Tab Stops"
			, Type: "Text", OutputSplit: " "}
		, {Prop: "Uppercase"}
		, {Prop: "WantCtrlA"
			, Default: "Yes"}
		, {Prop: "WantReturn"
			, Default: "Yes"}
		, {Prop: "WantTab"}]}

PropertiesDef.UpDown := {ControlType: "UpDown|2"
	, Properties: ["UpDown Properties"
		, {Prop: "Target"
			, Type: "Control", CustomOutput: 1}
		, {Prop: "Horz", Name: "Horizontal"
			, UsePropertyNameOnEdit: 1, RecreateOnEdit: 1}
		, {Prop: "Left"
			, UsePropertyNameOnEdit: 1, RecreateOnEdit: 1, EditorOnly: 1}
		, {Prop: "Range"
			, Type: "XY", SplitString: " > "
			, Range: ["", ""]}
		, {Prop: "NoThousandsSeparator", Name: "No Thousands Separator"
			, Constant: "UDS_NOTHOUSANDS"}]}

PropertiesDef.CheckBox := {ControlType: "CheckBox|2"
	, Properties: ["CheckBox Properties"
		, {Prop: "State"
			, Type: "List", Options: "Unchecked|Checked|Indeterminate"
			, OptionValues: "0||Gray", OutputPrefix: "Checked"
			, Default: "Unchecked"}
		, {Prop: "Check3", Name: "Allow Gray Check"}]}

PropertiesDef.Radio := {ControlType: "Radio|2"
	, Properties: ["Radio Properties"
		, {Prop: "Checked"}
		, {Prop: "Group"
			, Type: "Var", Limit: 20
			, Default: "1"
			, CustomOutput: 1}]}

PropertiesDef.DropDownList := PropertiesDef.ComboBox := {ControlType: "DropDownList,ComboBox|2"
	, Properties: ["ComboBox Properties"
		, {Prop: "Choose", Name: "Selected Item"
			, Type: "Int", Range: [0, ""], Default: 0
			, OutputIgnore0: 1}
		, {Prop: "Lowercase", RecreateOnEdit: 1}
		, {Prop: "Simple", RecreateOnEdit: 1
			, ControlTypes: {"": ""
				, DropDownList: {Disable: 1} }}
		, {Prop: "Sort", RecreateOnEdit: 1}
		, {Prop: "Uppercase", RecreateOnEdit: 1}]}

PropertiesDef.ListBox := {ControlType: "ListBox|2"
	, Properties: ["ListBox Properties"
		, {Prop: "Choose", Name: "Selected Item"
			, Type: "Int", Range: [0, ""], Default: 0
			, OutputIgnore0: 1}
		, {Prop: "Multi", Name: "Multi Select"
			, Type: "List", Options: "Disabled|Enabled|Simple", OptionValues: "|Multi|LBS_MULTIPLESEL", Constant3: 1
			, Default: "Disabled"}
		, {Prop: "ReadOnly"}
		, {Prop: "Sort", UsePropertyNameOnEdit: 1, RecreateOnEdit: 1}
		, {Prop: "T", Name: "Tab Stops"
			, Type: "Text", OutputSplit: " "}
		, {Prop: "NoIntegralHeight", Name: "No Integral Height"
			, Constant: "LBS_NOINTEGRALHEIGHT", RecreateOnEdit: 1}]}

PropertiesDef.ListView := {ControlType: "ListView|2"
	, Options: {MultiTextOptionInsertText: "Column"}
	, Properties: ["ListView Properties"
		, {Prop: "AltSubmit"}
		, {Prop: "Checked"}
		, {Prop: "Count"
			, Type: "Int", OutputIgnore0: 1}
		, {Prop: "Grid"}
		, {Prop: "Hdr"
			, Default: "Yes"}
		, {Prop: "HeaderDragDrop", Prop: "Header Drag Drop"
			, Default: "Yes", Constant: "LVS_EX_HEADERDRAGDROP", OutputPrefix: "LV"}
		, {Prop: "FullRowSelect", Prop: "Full Row Select"
			, Default: "Yes", Constant: "LVS_EX_FULLROWSELECT", OutputPrefix: "LV"}
		, {Prop: "Multi"
			, Default: "Yes"}
		, {Prop: "NoSortHdr"}
		, {Prop: "NoSort"}
		, {Prop: "ReadOnly"
			, Default: "Yes"}
		, {Prop: "Sort"
			, Type: "List", Options: "None|Ascending|Descending", OptionValues: "|Sort|SortDesc"
			, Default: "None"}
		, {Prop: "ViewMode", Name: "View Mode"
			, Type: "List", Options: "Icon|IconSmall|List|Tile|Report"
			, Default: "Report"}
		, {Prop: "WantF2 "
			, Default: "Yes"}]}

PropertiesDef.TreeView := {ControlType: "TreeView|2"
	, Properties: ["ListView Properties"
		, {Prop: "AltSubmit"}
		, {Prop: "Buttons"
			, Default: "Yes"}
		, {Prop: "Checked"}
		, {Prop: "Lines"
			, Default: "Yes"}
		, {Prop: "ReadOnly"
			, Default: "Yes"}
		, {Prop: "WantF2 "
			, Default: "Yes"}]}

PropertiesDef.Hotkey := {ControlType: "Hotkey|2"
	, Properties: ["Hotkey Properties"
		, {Prop: "UnmodifiedKeys", Name: "Unmodified Keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 1}
		, {Prop: "ShiftOnlyKeys", Name: "Shift-only Keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 2}
		, {Prop: "ControlOnlyKeys", Name: "Control-only Keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 4}
		, {Prop: "AltOnlyKeys", Name: "Alt-only Keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 8}
		, {Prop: "ShiftControlKeys", Name: "Shift-Control keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 16}
		, {Prop: "ShiftAltKeys", Name: "Shift-Alt keys"
			, Default: "Yes", CustomOutput: 1, OutputValue: 32}
		, {Prop: "ShiftControlAltKeys", Name: "Shift-Control-Alt keys"
			, Default: "Yes", CustomOutput: 1, CompositeOutput1: ["UnmodifiedKeys", "ShiftOnlyKeys", "ControlOnlyKeys", "AltOnlyKeys", "ShiftControlKeys", "ShiftAltKeys", "ShiftControlAltKeys"]
			, OutputValue: 128, OutputName1: "Limit"}
		, {Prop: "Limit", NoDisplay: 1
			, Type: "Composite", Properties: ["UnmodifiedKeys", "ShiftOnlyKeys", "ControlOnlyKeys", "AltOnlyKeys", "ShiftControlKeys", "ShiftAltKeys", "ShiftControlAltKeys"]
			, CompositeFunction: "Add"} ]}

PropertiesDef.DateTime := {ControlType: "DateTime|2"
	, Properties: ["DateTime Properties"
		, {Prop: "Date", Name: "Date"
			, Type: "List", Options: "Default|Selected|None", OptionValues: "||ChooseNone"
			, Default: "Default", EditPropertyName: "DateTimeDate"}
		, {Prop: "SelectedDate", Name: "Selected Date"
			, Type: "Date", ShowTime: 1, OutputName: "Choose", OnlyIf: ["Date", "Selected"]
			, EditPropertyName: "DateTimeDate", EmptyValueVar: "A_Now"}
		, {Prop: "Range", Name: "Range"
			, Type: "DateRange", NoTime: 1}
		, {Prop: "Right"}
		, {Prop: "DateTimeUpDown", Name: "UpDown"
			, Constant: "DTS_UPDOWN", RecreateOnEdit: 1}
		, {Prop: "DateTimeCheckBox", Name: "CheckBox"
			, Constant: "DTS_SHOWNONE", RecreateOnEdit: 1}]}

PropertiesDef.MonthCal := {ControlType: "MonthCal|2"
	, Properties: ["MonthCal Properties"
		, {Prop: "Range", Name: "Range"
			, Type: "DateRange", NoTime: 1}
		, {Prop: "Multi"}
		, {Prop: "NoToday", Name: "No Today"
			, Constant: "MCS_NOTODAY", UseConstantOnEdit: 1}
		, {Prop: "NoTodayCircle", Name: "No Today Circle"
			, Constant: "MCS_NOTODAYCIRCLE", UseConstantOnEdit: 1}
		, {Prop: "WeekNumbers", Name: "Show Week Numbers"
			, Constant: "MCS_WEEKNUMBERS", UseConstantOnEdit: 1} ]}

PropertiesDef.Slider := {ControlType: "Slider|2"
	, Properties: ["Slider Properties"
		, {Prop: "Buddy1"
			, Type: "Var"}
		, {Prop: "Buddy2"
			, Type: "Var"}
		, {Prop: "Center", UsePropertyNameOnEdit: 1}
		, {Prop: "Line"
			, Type: "Int", OutputIgnore0: 1}
		, {Prop: "NoTicks", UsePropertyNameOnEdit: 1}
		, {Prop: "Page"
			, Type: "Int", OutputIgnore0: 1}
		, {Prop: "Range"
			, Type: "XY", SplitString: " > "
			, Default: [0, 100]}
		, {Prop: "Thick"
			, Type: "Int", UsePropertyNameOnEdit: 1, OutputIgnore0: 1}
		, {Prop: "TickInterval"
			, Type: "Int", UsePropertyNameOnEdit: 1, OutputIgnore0: 1}
		, {Prop: "ToolTip"
			, Type: "List", Options: "None|Left|Top|Right|Bottom", OptionsValues: "|Left|Top|Right|Bottom"
			, Default: "None"
			, OutputPrefix: "ToolTip"}
		, {Prop: "Vertical", UsePropertyNameOnEdit: 1} ]}

PropertiesDef.Progress := {ControlType: "Progress|2"
	, Properties: ["Progress Properties"
		, {Prop: "Range"
			, Type: "XY", SplitString: " > "
			, Default: [0, 100]}
		, {Prop: "Smooth"
			, Default: "Yes"}
		, {Prop: "Vertical", UsePropertyNameOnEdit: 1} ]}

PropertiesDef.Tab2 := {ControlType: "Tab2|2"
	, Options: {MultiTextOptionInsertText: "Tab"}
	, Properties: ["Tab Properties"
		, {Prop: "Choose", Name: "Selected Tab"
			, Type: "Int", Range: [0, ""]
			, OutputIgnore0: 1, OutputIgnore1: 1}
		, {Prop: "Buttons", UsePropertyNameOnEdit: 1}
		, {Prop: "TabPositions", Name: "Tab Positions", RecreateOnEdit: 1
			, Type: "List", Options: "Top|Bottom|Left|Right", Default: "Top"} ]}

PropertiesDef.StatusBar := {ControlType: ""
	, Options: {NoResize: 1}}

; Options			: Options added when a new control is created
; ForceOptions		: Options added even when a control is loaded from file
; AddModifierKeys	: Extra text modifier key text added to the status when a control is being added
; ResetDataOnCopy	: When copying/pasting controls any data with these names will be cleared/removed
global ControlTypeOptions := {EditorWin: {Options: "w400 h300"}
	, Text: {Text: "Label Text"}
	, Edit: {Options: "Multi -VScroll r1", ForceOptions: "Multi -VScroll"}
	, UpDown: {Text: 0, AddModifierKeys: " | Auto Buddy: Alt"}
	, Picture: {Options: "w50 h50 Border"}
	, Button: {Text: "Button"}
	, Checkbox: {Text: "Checkbox", States: {Unchecked: "0", Checked: "1", Indeterminate: "-1"}}
	, Radio: {Text: "Radio", Options: "Group", ForceOptions: "Group"}
	, Link: {Text: "<a href="""">Link</a> Text"}
	, MonthCal: {Options: "Multi", ForceOptions: "Multi"}
	, Slider: {Text: 0}
	, Progress: {Text: 50, NoGuiTextColour: 1, NoGuiBGColour: 1}
	, GroupBox: {Text: "Group Box"}
	, Tab2: {Text: "Tab 1" GUI_DELIMITER "Tab 2"}
	, StatusBar: {NoMove: 1, NoResize: 1, IsUnique: 1, UpdateOnResize: 1}
	, ActiveX: {PlaceHolder: "Text", PlaceHolderTpl: "ActiveX <Text>", Options: "w50 h50 Border -Wrap", ForceOptions: "Border"}
	, Custom: {PlaceHolder: "Text", PlaceHolderTpl: "Custom <Text>", Options: "w50 h50 Border -Wrap", ForceOptions: "Border"}
	, ResetDataOnCopy: ["_HasChildrenOnPage"]}